<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBlocEtab ArrayType
 * @subpackage Arrays
 */
class ArrayOfBlocEtab extends AbstractStructArrayBase
{
    /**
     * The BlocEtab
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BlocEtab[]
     */
    public $BlocEtab;
    /**
     * Constructor method for ArrayOfBlocEtab
     * @uses ArrayOfBlocEtab::setBlocEtab()
     * @param \StructType\BlocEtab[] $blocEtab
     */
    public function __construct(array $blocEtab = array())
    {
        $this
            ->setBlocEtab($blocEtab);
    }
    /**
     * Get BlocEtab value
     * @return \StructType\BlocEtab[]|null
     */
    public function getBlocEtab()
    {
        return $this->BlocEtab;
    }
    /**
     * Set BlocEtab value
     * @throws \InvalidArgumentException
     * @param \StructType\BlocEtab[] $blocEtab
     * @return \ArrayType\ArrayOfBlocEtab
     */
    public function setBlocEtab(array $blocEtab = array())
    {
        foreach ($blocEtab as $arrayOfBlocEtabBlocEtabItem) {
            // validation for constraint: itemType
            if (!$arrayOfBlocEtabBlocEtabItem instanceof \StructType\BlocEtab) {
                throw new \InvalidArgumentException(sprintf('The BlocEtab property can only contain items of \StructType\BlocEtab, "%s" given', is_object($arrayOfBlocEtabBlocEtabItem) ? get_class($arrayOfBlocEtabBlocEtabItem) : gettype($arrayOfBlocEtabBlocEtabItem)), __LINE__);
            }
        }
        $this->BlocEtab = $blocEtab;
        return $this;
    }
    /**
     * Add item to BlocEtab value
     * @throws \InvalidArgumentException
     * @param \StructType\BlocEtab $item
     * @return \ArrayType\ArrayOfBlocEtab
     */
    public function addToBlocEtab(\StructType\BlocEtab $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BlocEtab) {
            throw new \InvalidArgumentException(sprintf('The BlocEtab property can only contain items of \StructType\BlocEtab, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BlocEtab[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BlocEtab|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BlocEtab|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BlocEtab|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BlocEtab|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BlocEtab|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BlocEtab
     */
    public function getAttributeName()
    {
        return 'BlocEtab';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBlocEtab
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
