<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BlocMdia StructType
 * @subpackage Structs
 */
class BlocMdia extends AbstractStructBase
{
    /**
     * The CdTypeMdia
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdTypeMdia;
    /**
     * The CdTypeUsgMdia
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdTypeUsgMdia;
    /**
     * The InPrfcMdia
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $InPrfcMdia;
    /**
     * The RfAccesMdia
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $RfAccesMdia;
    /**
     * The CdValdMdia
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CdValdMdia;
    /**
     * Constructor method for BlocMdia
     * @uses BlocMdia::setCdTypeMdia()
     * @uses BlocMdia::setCdTypeUsgMdia()
     * @uses BlocMdia::setInPrfcMdia()
     * @uses BlocMdia::setRfAccesMdia()
     * @uses BlocMdia::setCdValdMdia()
     * @param string $cdTypeMdia
     * @param string $cdTypeUsgMdia
     * @param string $inPrfcMdia
     * @param string $rfAccesMdia
     * @param string $cdValdMdia
     */
    public function __construct($cdTypeMdia = null, $cdTypeUsgMdia = null, $inPrfcMdia = null, $rfAccesMdia = null, $cdValdMdia = null)
    {
        $this
            ->setCdTypeMdia($cdTypeMdia)
            ->setCdTypeUsgMdia($cdTypeUsgMdia)
            ->setInPrfcMdia($inPrfcMdia)
            ->setRfAccesMdia($rfAccesMdia)
            ->setCdValdMdia($cdValdMdia);
    }
    /**
     * Get CdTypeMdia value
     * @return string
     */
    public function getCdTypeMdia()
    {
        return $this->CdTypeMdia;
    }
    /**
     * Set CdTypeMdia value
     * @param string $cdTypeMdia
     * @return \StructType\BlocMdia
     */
    public function setCdTypeMdia($cdTypeMdia = null)
    {
        // validation for constraint: string
        if (!is_null($cdTypeMdia) && !is_string($cdTypeMdia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdTypeMdia)), __LINE__);
        }
        $this->CdTypeMdia = $cdTypeMdia;
        return $this;
    }
    /**
     * Get CdTypeUsgMdia value
     * @return string
     */
    public function getCdTypeUsgMdia()
    {
        return $this->CdTypeUsgMdia;
    }
    /**
     * Set CdTypeUsgMdia value
     * @param string $cdTypeUsgMdia
     * @return \StructType\BlocMdia
     */
    public function setCdTypeUsgMdia($cdTypeUsgMdia = null)
    {
        // validation for constraint: string
        if (!is_null($cdTypeUsgMdia) && !is_string($cdTypeUsgMdia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdTypeUsgMdia)), __LINE__);
        }
        $this->CdTypeUsgMdia = $cdTypeUsgMdia;
        return $this;
    }
    /**
     * Get InPrfcMdia value
     * @return string
     */
    public function getInPrfcMdia()
    {
        return $this->InPrfcMdia;
    }
    /**
     * Set InPrfcMdia value
     * @param string $inPrfcMdia
     * @return \StructType\BlocMdia
     */
    public function setInPrfcMdia($inPrfcMdia = null)
    {
        // validation for constraint: string
        if (!is_null($inPrfcMdia) && !is_string($inPrfcMdia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($inPrfcMdia)), __LINE__);
        }
        $this->InPrfcMdia = $inPrfcMdia;
        return $this;
    }
    /**
     * Get RfAccesMdia value
     * @return string
     */
    public function getRfAccesMdia()
    {
        return $this->RfAccesMdia;
    }
    /**
     * Set RfAccesMdia value
     * @param string $rfAccesMdia
     * @return \StructType\BlocMdia
     */
    public function setRfAccesMdia($rfAccesMdia = null)
    {
        // validation for constraint: string
        if (!is_null($rfAccesMdia) && !is_string($rfAccesMdia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rfAccesMdia)), __LINE__);
        }
        $this->RfAccesMdia = $rfAccesMdia;
        return $this;
    }
    /**
     * Get CdValdMdia value
     * @return string|null
     */
    public function getCdValdMdia()
    {
        return $this->CdValdMdia;
    }
    /**
     * Set CdValdMdia value
     * @param string $cdValdMdia
     * @return \StructType\BlocMdia
     */
    public function setCdValdMdia($cdValdMdia = null)
    {
        // validation for constraint: string
        if (!is_null($cdValdMdia) && !is_string($cdValdMdia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdValdMdia)), __LINE__);
        }
        $this->CdValdMdia = $cdValdMdia;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BlocMdia
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
