<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BlocPersPhys StructType
 * @subpackage Structs
 */
class BlocPersPhys extends AbstractStructBase
{
    /**
     * The CdCivl
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdCivl;
    /**
     * The CdSexe
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdSexe;
    /**
     * The NomPatr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $NomPatr;
    /**
     * The Prnm
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Prnm;
    /**
     * The BlocEtatCivil
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\BlocEtatCivl
     */
    public $BlocEtatCivil;
    /**
     * The BlocPartc
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\BlocPartc
     */
    public $BlocPartc;
    /**
     * The BlocEtatCivl
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\BlocEtatCivl
     */
    public $BlocEtatCivl;
    /**
     * The NomMart
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NomMart;
    /**
     * The NomUsg
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NomUsg;
    /**
     * The DtNais
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - maxLength: 8
     * @var string
     */
    public $DtNais;
    /**
     * Constructor method for BlocPersPhys
     * @uses BlocPersPhys::setCdCivl()
     * @uses BlocPersPhys::setCdSexe()
     * @uses BlocPersPhys::setNomPatr()
     * @uses BlocPersPhys::setPrnm()
     * @uses BlocPersPhys::setBlocEtatCivil()
     * @uses BlocPersPhys::setBlocPartc()
     * @uses BlocPersPhys::setBlocEtatCivl()
     * @uses BlocPersPhys::setNomMart()
     * @uses BlocPersPhys::setNomUsg()
     * @uses BlocPersPhys::setDtNais()
     * @param string $cdCivl
     * @param string $cdSexe
     * @param string $nomPatr
     * @param string $prnm
     * @param \StructType\BlocEtatCivl $blocEtatCivil
     * @param \StructType\BlocPartc $blocPartc
     * @param \StructType\BlocEtatCivl $blocEtatCivl
     * @param string $nomMart
     * @param string $nomUsg
     * @param string $dtNais
     */
    public function __construct($cdCivl = null, $cdSexe = null, $nomPatr = null, $prnm = null, \StructType\BlocEtatCivl $blocEtatCivil = null, \StructType\BlocPartc $blocPartc = null, \StructType\BlocEtatCivl $blocEtatCivl = null, $nomMart = null, $nomUsg = null, $dtNais = null)
    {
        $this
            ->setCdCivl($cdCivl)
            ->setCdSexe($cdSexe)
            ->setNomPatr($nomPatr)
            ->setPrnm($prnm)
            ->setBlocEtatCivil($blocEtatCivil)
            ->setBlocPartc($blocPartc)
            ->setBlocEtatCivl($blocEtatCivl)
            ->setNomMart($nomMart)
            ->setNomUsg($nomUsg)
            ->setDtNais($dtNais);
    }
    /**
     * Get CdCivl value
     * @return string
     */
    public function getCdCivl()
    {
        return $this->CdCivl;
    }
    /**
     * Set CdCivl value
     * @param string $cdCivl
     * @return \StructType\BlocPersPhys
     */
    public function setCdCivl($cdCivl = null)
    {
        // validation for constraint: string
        if (!is_null($cdCivl) && !is_string($cdCivl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdCivl)), __LINE__);
        }
        $this->CdCivl = $cdCivl;
        return $this;
    }
    /**
     * Get CdSexe value
     * @return string
     */
    public function getCdSexe()
    {
        return $this->CdSexe;
    }
    /**
     * Set CdSexe value
     * @param string $cdSexe
     * @return \StructType\BlocPersPhys
     */
    public function setCdSexe($cdSexe = null)
    {
        // validation for constraint: string
        if (!is_null($cdSexe) && !is_string($cdSexe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdSexe)), __LINE__);
        }
        $this->CdSexe = $cdSexe;
        return $this;
    }
    /**
     * Get NomPatr value
     * @return string
     */
    public function getNomPatr()
    {
        return $this->NomPatr;
    }
    /**
     * Set NomPatr value
     * @param string $nomPatr
     * @return \StructType\BlocPersPhys
     */
    public function setNomPatr($nomPatr = null)
    {
        // validation for constraint: string
        if (!is_null($nomPatr) && !is_string($nomPatr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nomPatr)), __LINE__);
        }
        $this->NomPatr = $nomPatr;
        return $this;
    }
    /**
     * Get Prnm value
     * @return string
     */
    public function getPrnm()
    {
        return $this->Prnm;
    }
    /**
     * Set Prnm value
     * @param string $prnm
     * @return \StructType\BlocPersPhys
     */
    public function setPrnm($prnm = null)
    {
        // validation for constraint: string
        if (!is_null($prnm) && !is_string($prnm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prnm)), __LINE__);
        }
        $this->Prnm = $prnm;
        return $this;
    }
    /**
     * Get BlocEtatCivil value
     * @return \StructType\BlocEtatCivl
     */
    public function getBlocEtatCivil()
    {
        return $this->BlocEtatCivil;
    }
    /**
     * Set BlocEtatCivil value
     * @param \StructType\BlocEtatCivl $blocEtatCivil
     * @return \StructType\BlocPersPhys
     */
    public function setBlocEtatCivil(\StructType\BlocEtatCivl $blocEtatCivil = null)
    {
        $this->BlocEtatCivil = $blocEtatCivil;
        return $this;
    }
    /**
     * Get BlocPartc value
     * @return \StructType\BlocPartc
     */
    public function getBlocPartc()
    {
        return $this->BlocPartc;
    }
    /**
     * Set BlocPartc value
     * @param \StructType\BlocPartc $blocPartc
     * @return \StructType\BlocPersPhys
     */
    public function setBlocPartc(\StructType\BlocPartc $blocPartc = null)
    {
        $this->BlocPartc = $blocPartc;
        return $this;
    }
    /**
     * Get BlocEtatCivl value
     * @return \StructType\BlocEtatCivl
     */
    public function getBlocEtatCivl()
    {
        return $this->BlocEtatCivl;
    }
    /**
     * Set BlocEtatCivl value
     * @param \StructType\BlocEtatCivl $blocEtatCivl
     * @return \StructType\BlocPersPhys
     */
    public function setBlocEtatCivl(\StructType\BlocEtatCivl $blocEtatCivl = null)
    {
        $this->BlocEtatCivl = $blocEtatCivl;
        return $this;
    }
    /**
     * Get NomMart value
     * @return string|null
     */
    public function getNomMart()
    {
        return $this->NomMart;
    }
    /**
     * Set NomMart value
     * @param string $nomMart
     * @return \StructType\BlocPersPhys
     */
    public function setNomMart($nomMart = null)
    {
        // validation for constraint: string
        if (!is_null($nomMart) && !is_string($nomMart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nomMart)), __LINE__);
        }
        $this->NomMart = $nomMart;
        return $this;
    }
    /**
     * Get NomUsg value
     * @return string|null
     */
    public function getNomUsg()
    {
        return $this->NomUsg;
    }
    /**
     * Set NomUsg value
     * @param string $nomUsg
     * @return \StructType\BlocPersPhys
     */
    public function setNomUsg($nomUsg = null)
    {
        // validation for constraint: string
        if (!is_null($nomUsg) && !is_string($nomUsg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nomUsg)), __LINE__);
        }
        $this->NomUsg = $nomUsg;
        return $this;
    }
    /**
     * Get DtNais value
     * @return string|null
     */
    public function getDtNais()
    {
        return $this->DtNais;
    }
    /**
     * Set DtNais value
     * @param string $dtNais
     * @return \StructType\BlocPersPhys
     */
    public function setDtNais($dtNais = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($dtNais) && strlen($dtNais) > 8) || (is_array($dtNais) && count($dtNais) > 8)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 8 element(s) or a scalar of 8 character(s) at most, "%d" length given', is_scalar($dtNais) ? strlen($dtNais) : count($dtNais)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($dtNais) && !is_string($dtNais)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dtNais)), __LINE__);
        }
        $this->DtNais = $dtNais;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BlocPersPhys
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
