<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BlocReltBanq StructType
 * @subpackage Structs
 */
class BlocReltBanq extends AbstractStructBase
{
    /**
     * The CdApparRes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdApparRes;
    /**
     * The CdTypeRelt
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CdTypeRelt;
    /**
     * The DtEntrRelt
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DtEntrRelt;
    /**
     * The InSocr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InSocr;
    /**
     * Constructor method for BlocReltBanq
     * @uses BlocReltBanq::setCdApparRes()
     * @uses BlocReltBanq::setCdTypeRelt()
     * @uses BlocReltBanq::setDtEntrRelt()
     * @uses BlocReltBanq::setInSocr()
     * @param string $cdApparRes
     * @param string $cdTypeRelt
     * @param string $dtEntrRelt
     * @param string $inSocr
     */
    public function __construct($cdApparRes = null, $cdTypeRelt = null, $dtEntrRelt = null, $inSocr = null)
    {
        $this
            ->setCdApparRes($cdApparRes)
            ->setCdTypeRelt($cdTypeRelt)
            ->setDtEntrRelt($dtEntrRelt)
            ->setInSocr($inSocr);
    }
    /**
     * Get CdApparRes value
     * @return string
     */
    public function getCdApparRes()
    {
        return $this->CdApparRes;
    }
    /**
     * Set CdApparRes value
     * @param string $cdApparRes
     * @return \StructType\BlocReltBanq
     */
    public function setCdApparRes($cdApparRes = null)
    {
        // validation for constraint: string
        if (!is_null($cdApparRes) && !is_string($cdApparRes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdApparRes)), __LINE__);
        }
        $this->CdApparRes = $cdApparRes;
        return $this;
    }
    /**
     * Get CdTypeRelt value
     * @return string|null
     */
    public function getCdTypeRelt()
    {
        return $this->CdTypeRelt;
    }
    /**
     * Set CdTypeRelt value
     * @param string $cdTypeRelt
     * @return \StructType\BlocReltBanq
     */
    public function setCdTypeRelt($cdTypeRelt = null)
    {
        // validation for constraint: string
        if (!is_null($cdTypeRelt) && !is_string($cdTypeRelt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdTypeRelt)), __LINE__);
        }
        $this->CdTypeRelt = $cdTypeRelt;
        return $this;
    }
    /**
     * Get DtEntrRelt value
     * @return string|null
     */
    public function getDtEntrRelt()
    {
        return $this->DtEntrRelt;
    }
    /**
     * Set DtEntrRelt value
     * @param string $dtEntrRelt
     * @return \StructType\BlocReltBanq
     */
    public function setDtEntrRelt($dtEntrRelt = null)
    {
        // validation for constraint: string
        if (!is_null($dtEntrRelt) && !is_string($dtEntrRelt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dtEntrRelt)), __LINE__);
        }
        $this->DtEntrRelt = $dtEntrRelt;
        return $this;
    }
    /**
     * Get InSocr value
     * @return string|null
     */
    public function getInSocr()
    {
        return $this->InSocr;
    }
    /**
     * Set InSocr value
     * @param string $inSocr
     * @return \StructType\BlocReltBanq
     */
    public function setInSocr($inSocr = null)
    {
        // validation for constraint: string
        if (!is_null($inSocr) && !is_string($inSocr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($inSocr)), __LINE__);
        }
        $this->InSocr = $inSocr;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BlocReltBanq
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
