<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BlocRetr StructType
 * @subpackage Structs
 */
class BlocRetr extends AbstractStructBase
{
    /**
     * The CdTypeRetr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdTypeRetr;
    /**
     * The BlocMess
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\BlocMess
     */
    public $BlocMess;
    /**
     * Constructor method for BlocRetr
     * @uses BlocRetr::setCdTypeRetr()
     * @uses BlocRetr::setBlocMess()
     * @param string $cdTypeRetr
     * @param \StructType\BlocMess $blocMess
     */
    public function __construct($cdTypeRetr = null, \StructType\BlocMess $blocMess = null)
    {
        $this
            ->setCdTypeRetr($cdTypeRetr)
            ->setBlocMess($blocMess);
    }
    /**
     * Get CdTypeRetr value
     * @return string
     */
    public function getCdTypeRetr()
    {
        return $this->CdTypeRetr;
    }
    /**
     * Set CdTypeRetr value
     * @param string $cdTypeRetr
     * @return \StructType\BlocRetr
     */
    public function setCdTypeRetr($cdTypeRetr = null)
    {
        // validation for constraint: string
        if (!is_null($cdTypeRetr) && !is_string($cdTypeRetr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdTypeRetr)), __LINE__);
        }
        $this->CdTypeRetr = $cdTypeRetr;
        return $this;
    }
    /**
     * Get BlocMess value
     * @return \StructType\BlocMess|null
     */
    public function getBlocMess()
    {
        return $this->BlocMess;
    }
    /**
     * Set BlocMess value
     * @param \StructType\BlocMess $blocMess
     * @return \StructType\BlocRetr
     */
    public function setBlocMess(\StructType\BlocMess $blocMess = null)
    {
        $this->BlocMess = $blocMess;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BlocRetr
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
