<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BlocTiers StructType
 * @subpackage Structs
 */
class BlocTiers extends AbstractStructBase
{
    /**
     * The CdEtabFinnTier
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdEtabFinnTier;
    /**
     * The IdTier
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $IdTier;
    /**
     * The CdPersJurd
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdPersJurd;
    /**
     * The CdStttTier
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CdStttTier;
    /**
     * The BlocReltBanq
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\BlocReltBanq
     */
    public $BlocReltBanq;
    /**
     * The BlocPersPhys
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\BlocPersPhys
     */
    public $BlocPersPhys;
    /**
     * The ListLienTiersEDS
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\BlocLienTiersEDS[]
     */
    public $ListLienTiersEDS;
    /**
     * The BlocPartc
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\BlocPartc
     */
    public $BlocPartc;
    /**
     * The BlocEntidv
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\BlocEntidv
     */
    public $BlocEntidv;
    /**
     * The BlocPersMorlAssmr
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BlocPersMorlAssmr
     */
    public $BlocPersMorlAssmr;
    /**
     * The BlocMoyeComm
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BlocMoyeComm
     */
    public $BlocMoyeComm;
    /**
     * The BlocRelatDigitBanq
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BlocRelatDigitBanq
     */
    public $BlocRelatDigitBanq;
    /**
     * Constructor method for BlocTiers
     * @uses BlocTiers::setCdEtabFinnTier()
     * @uses BlocTiers::setIdTier()
     * @uses BlocTiers::setCdPersJurd()
     * @uses BlocTiers::setCdStttTier()
     * @uses BlocTiers::setBlocReltBanq()
     * @uses BlocTiers::setBlocPersPhys()
     * @uses BlocTiers::setListLienTiersEDS()
     * @uses BlocTiers::setBlocPartc()
     * @uses BlocTiers::setBlocEntidv()
     * @uses BlocTiers::setBlocPersMorlAssmr()
     * @uses BlocTiers::setBlocMoyeComm()
     * @uses BlocTiers::setBlocRelatDigitBanq()
     * @param string $cdEtabFinnTier
     * @param string $idTier
     * @param string $cdPersJurd
     * @param string $cdStttTier
     * @param \StructType\BlocReltBanq $blocReltBanq
     * @param \StructType\BlocPersPhys $blocPersPhys
     * @param \StructType\BlocLienTiersEDS[] $listLienTiersEDS
     * @param \StructType\BlocPartc $blocPartc
     * @param \StructType\BlocEntidv $blocEntidv
     * @param \StructType\BlocPersMorlAssmr $blocPersMorlAssmr
     * @param \StructType\BlocMoyeComm $blocMoyeComm
     * @param \StructType\BlocRelatDigitBanq $blocRelatDigitBanq
     */
    public function __construct($cdEtabFinnTier = null, $idTier = null, $cdPersJurd = null, $cdStttTier = null, \StructType\BlocReltBanq $blocReltBanq = null, \StructType\BlocPersPhys $blocPersPhys = null, array $listLienTiersEDS = array(), \StructType\BlocPartc $blocPartc = null, \StructType\BlocEntidv $blocEntidv = null, \StructType\BlocPersMorlAssmr $blocPersMorlAssmr = null, \StructType\BlocMoyeComm $blocMoyeComm = null, \StructType\BlocRelatDigitBanq $blocRelatDigitBanq = null)
    {
        $this
            ->setCdEtabFinnTier($cdEtabFinnTier)
            ->setIdTier($idTier)
            ->setCdPersJurd($cdPersJurd)
            ->setCdStttTier($cdStttTier)
            ->setBlocReltBanq($blocReltBanq)
            ->setBlocPersPhys($blocPersPhys)
            ->setListLienTiersEDS($listLienTiersEDS)
            ->setBlocPartc($blocPartc)
            ->setBlocEntidv($blocEntidv)
            ->setBlocPersMorlAssmr($blocPersMorlAssmr)
            ->setBlocMoyeComm($blocMoyeComm)
            ->setBlocRelatDigitBanq($blocRelatDigitBanq);
    }
    /**
     * Get CdEtabFinnTier value
     * @return string
     */
    public function getCdEtabFinnTier()
    {
        return $this->CdEtabFinnTier;
    }
    /**
     * Set CdEtabFinnTier value
     * @param string $cdEtabFinnTier
     * @return \StructType\BlocTiers
     */
    public function setCdEtabFinnTier($cdEtabFinnTier = null)
    {
        // validation for constraint: string
        if (!is_null($cdEtabFinnTier) && !is_string($cdEtabFinnTier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdEtabFinnTier)), __LINE__);
        }
        $this->CdEtabFinnTier = $cdEtabFinnTier;
        return $this;
    }
    /**
     * Get IdTier value
     * @return string
     */
    public function getIdTier()
    {
        return $this->IdTier;
    }
    /**
     * Set IdTier value
     * @param string $idTier
     * @return \StructType\BlocTiers
     */
    public function setIdTier($idTier = null)
    {
        // validation for constraint: string
        if (!is_null($idTier) && !is_string($idTier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idTier)), __LINE__);
        }
        $this->IdTier = $idTier;
        return $this;
    }
    /**
     * Get CdPersJurd value
     * @return string
     */
    public function getCdPersJurd()
    {
        return $this->CdPersJurd;
    }
    /**
     * Set CdPersJurd value
     * @param string $cdPersJurd
     * @return \StructType\BlocTiers
     */
    public function setCdPersJurd($cdPersJurd = null)
    {
        // validation for constraint: string
        if (!is_null($cdPersJurd) && !is_string($cdPersJurd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdPersJurd)), __LINE__);
        }
        $this->CdPersJurd = $cdPersJurd;
        return $this;
    }
    /**
     * Get CdStttTier value
     * @return string
     */
    public function getCdStttTier()
    {
        return $this->CdStttTier;
    }
    /**
     * Set CdStttTier value
     * @param string $cdStttTier
     * @return \StructType\BlocTiers
     */
    public function setCdStttTier($cdStttTier = null)
    {
        // validation for constraint: string
        if (!is_null($cdStttTier) && !is_string($cdStttTier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cdStttTier)), __LINE__);
        }
        $this->CdStttTier = $cdStttTier;
        return $this;
    }
    /**
     * Get BlocReltBanq value
     * @return \StructType\BlocReltBanq
     */
    public function getBlocReltBanq()
    {
        return $this->BlocReltBanq;
    }
    /**
     * Set BlocReltBanq value
     * @param \StructType\BlocReltBanq $blocReltBanq
     * @return \StructType\BlocTiers
     */
    public function setBlocReltBanq(\StructType\BlocReltBanq $blocReltBanq = null)
    {
        $this->BlocReltBanq = $blocReltBanq;
        return $this;
    }
    /**
     * Get BlocPersPhys value
     * @return \StructType\BlocPersPhys
     */
    public function getBlocPersPhys()
    {
        return $this->BlocPersPhys;
    }
    /**
     * Set BlocPersPhys value
     * @param \StructType\BlocPersPhys $blocPersPhys
     * @return \StructType\BlocTiers
     */
    public function setBlocPersPhys(\StructType\BlocPersPhys $blocPersPhys = null)
    {
        $this->BlocPersPhys = $blocPersPhys;
        return $this;
    }
    /**
     * Get ListLienTiersEDS value
     * @return \StructType\BlocLienTiersEDS[]
     */
    public function getListLienTiersEDS()
    {
        return $this->ListLienTiersEDS;
    }
    /**
     * Set ListLienTiersEDS value
     * @throws \InvalidArgumentException
     * @param \StructType\BlocLienTiersEDS[] $listLienTiersEDS
     * @return \StructType\BlocTiers
     */
    public function setListLienTiersEDS(array $listLienTiersEDS = array())
    {
        foreach ($listLienTiersEDS as $blocTiersListLienTiersEDSItem) {
            // validation for constraint: itemType
            if (!$blocTiersListLienTiersEDSItem instanceof \StructType\BlocLienTiersEDS) {
                throw new \InvalidArgumentException(sprintf('The ListLienTiersEDS property can only contain items of \StructType\BlocLienTiersEDS, "%s" given', is_object($blocTiersListLienTiersEDSItem) ? get_class($blocTiersListLienTiersEDSItem) : gettype($blocTiersListLienTiersEDSItem)), __LINE__);
            }
        }
        $this->ListLienTiersEDS = $listLienTiersEDS;
        return $this;
    }
    /**
     * Add item to ListLienTiersEDS value
     * @throws \InvalidArgumentException
     * @param \StructType\BlocLienTiersEDS $item
     * @return \StructType\BlocTiers
     */
    public function addToListLienTiersEDS(\StructType\BlocLienTiersEDS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BlocLienTiersEDS) {
            throw new \InvalidArgumentException(sprintf('The ListLienTiersEDS property can only contain items of \StructType\BlocLienTiersEDS, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ListLienTiersEDS[] = $item;
        return $this;
    }
    /**
     * Get BlocPartc value
     * @return \StructType\BlocPartc
     */
    public function getBlocPartc()
    {
        return $this->BlocPartc;
    }
    /**
     * Set BlocPartc value
     * @param \StructType\BlocPartc $blocPartc
     * @return \StructType\BlocTiers
     */
    public function setBlocPartc(\StructType\BlocPartc $blocPartc = null)
    {
        $this->BlocPartc = $blocPartc;
        return $this;
    }
    /**
     * Get BlocEntidv value
     * @return \StructType\BlocEntidv|null
     */
    public function getBlocEntidv()
    {
        return $this->BlocEntidv;
    }
    /**
     * Set BlocEntidv value
     * @param \StructType\BlocEntidv $blocEntidv
     * @return \StructType\BlocTiers
     */
    public function setBlocEntidv(\StructType\BlocEntidv $blocEntidv = null)
    {
        $this->BlocEntidv = $blocEntidv;
        return $this;
    }
    /**
     * Get BlocPersMorlAssmr value
     * @return \StructType\BlocPersMorlAssmr|null
     */
    public function getBlocPersMorlAssmr()
    {
        return $this->BlocPersMorlAssmr;
    }
    /**
     * Set BlocPersMorlAssmr value
     * @param \StructType\BlocPersMorlAssmr $blocPersMorlAssmr
     * @return \StructType\BlocTiers
     */
    public function setBlocPersMorlAssmr(\StructType\BlocPersMorlAssmr $blocPersMorlAssmr = null)
    {
        $this->BlocPersMorlAssmr = $blocPersMorlAssmr;
        return $this;
    }
    /**
     * Get BlocMoyeComm value
     * @return \StructType\BlocMoyeComm|null
     */
    public function getBlocMoyeComm()
    {
        return $this->BlocMoyeComm;
    }
    /**
     * Set BlocMoyeComm value
     * @param \StructType\BlocMoyeComm $blocMoyeComm
     * @return \StructType\BlocTiers
     */
    public function setBlocMoyeComm(\StructType\BlocMoyeComm $blocMoyeComm = null)
    {
        $this->BlocMoyeComm = $blocMoyeComm;
        return $this;
    }
    /**
     * Get BlocRelatDigitBanq value
     * @return \StructType\BlocRelatDigitBanq|null
     */
    public function getBlocRelatDigitBanq()
    {
        return $this->BlocRelatDigitBanq;
    }
    /**
     * Set BlocRelatDigitBanq value
     * @param \StructType\BlocRelatDigitBanq $blocRelatDigitBanq
     * @return \StructType\BlocTiers
     */
    public function setBlocRelatDigitBanq(\StructType\BlocRelatDigitBanq $blocRelatDigitBanq = null)
    {
        $this->BlocRelatDigitBanq = $blocRelatDigitBanq;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BlocTiers
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
