<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RepnRecupTierLies StructType
 * @subpackage Structs
 */
class RepnRecupTierLies extends AbstractStructBase
{
    /**
     * The BlocRetr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\BlocRetr
     */
    public $BlocRetr;
    /**
     * The ListLienInterTiers
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BlocLienInterTiers[]
     */
    public $ListLienInterTiers;
    /**
     * Constructor method for RepnRecupTierLies
     * @uses RepnRecupTierLies::setBlocRetr()
     * @uses RepnRecupTierLies::setListLienInterTiers()
     * @param \StructType\BlocRetr $blocRetr
     * @param \StructType\BlocLienInterTiers[] $listLienInterTiers
     */
    public function __construct(\StructType\BlocRetr $blocRetr = null, array $listLienInterTiers = array())
    {
        $this
            ->setBlocRetr($blocRetr)
            ->setListLienInterTiers($listLienInterTiers);
    }
    /**
     * Get BlocRetr value
     * @return \StructType\BlocRetr
     */
    public function getBlocRetr()
    {
        return $this->BlocRetr;
    }
    /**
     * Set BlocRetr value
     * @param \StructType\BlocRetr $blocRetr
     * @return \StructType\RepnRecupTierLies
     */
    public function setBlocRetr(\StructType\BlocRetr $blocRetr = null)
    {
        $this->BlocRetr = $blocRetr;
        return $this;
    }
    /**
     * Get ListLienInterTiers value
     * @return \StructType\BlocLienInterTiers[]|null
     */
    public function getListLienInterTiers()
    {
        return $this->ListLienInterTiers;
    }
    /**
     * Set ListLienInterTiers value
     * @throws \InvalidArgumentException
     * @param \StructType\BlocLienInterTiers[] $listLienInterTiers
     * @return \StructType\RepnRecupTierLies
     */
    public function setListLienInterTiers(array $listLienInterTiers = array())
    {
        foreach ($listLienInterTiers as $repnRecupTierLiesListLienInterTiersItem) {
            // validation for constraint: itemType
            if (!$repnRecupTierLiesListLienInterTiersItem instanceof \StructType\BlocLienInterTiers) {
                throw new \InvalidArgumentException(sprintf('The ListLienInterTiers property can only contain items of \StructType\BlocLienInterTiers, "%s" given', is_object($repnRecupTierLiesListLienInterTiersItem) ? get_class($repnRecupTierLiesListLienInterTiersItem) : gettype($repnRecupTierLiesListLienInterTiersItem)), __LINE__);
            }
        }
        $this->ListLienInterTiers = $listLienInterTiers;
        return $this;
    }
    /**
     * Add item to ListLienInterTiers value
     * @throws \InvalidArgumentException
     * @param \StructType\BlocLienInterTiers $item
     * @return \StructType\RepnRecupTierLies
     */
    public function addToListLienInterTiers(\StructType\BlocLienInterTiers $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BlocLienInterTiers) {
            throw new \InvalidArgumentException(sprintf('The ListLienInterTiers property can only contain items of \StructType\BlocLienInterTiers, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ListLienInterTiers[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RepnRecupTierLies
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
